/*************************MULTIPLEXED USART EXAMPLE***********************/
// This is a trivial example to demonstrate how a device with a single USART PORT
//can be connected to several devices using 74HC151(multiplexer) and 74HC138(demultiplexer)
//In this example, it is possible to connect up to 3 USART devices to the microcontroller
//Hardware flow control may be implemented
// by SEGUN ILORI (c)2014

/*************************************************************************/
#define ADD_A_TRIS        TRISD0_bit
#define ADD_A             RD0_bit

#define ADD_B_TRIS        TRISD1_bit
#define ADD_B             RD1_bit

#define ADD_C_TRIS        TRISD2_bit
#define ADD_C             RD2_bit

#define MUX_ENABLE_TRIS TRISD3_bit
#define MUX_ENABLE RD3_bit


char tmp, uart_in_buffer[128], chr =0;

void interrupt() iv 0x0008 ics ICS_AUTO {// high priority interrupt
     
      if(PIR1.RCIF){    //Recieve interrupt flag

        uart_in_buffer[chr] = UART1_Read();
        chr++;

        if(chr>=127)  //PREVENT OVERFLOW BY RESETTING chr to ZERO
           chr = 0;
        //YOUR CODE HERE
    }


}

void init_serial_port(){

      TRISC.TRISC7=1;//RX pin
      TRISC.TRISC6=0;//TX pin
      UART1_Init(9600);
      INTCON.GIE = 1;//enable global interrupts
      INTCON.PEIE = 1;//enable peripheral interrupts
      PIE1.RCIE=1;//enable usart recieve interrupt
      PIR1.RCIF=0;

}


void enable_gsm_uart(){
//communicate with gsm module
      ADD_A           = 0;
      ADD_B           = 0;
      ADD_C           = 0;
}
 void enable_gps_uart(){
 //communicate with gps device
    ADD_A           = 1;
    ADD_B           = 0;
    ADD_C           = 0;
}
void enable_pi_uart(){
//communicate with raspberry pi

    ADD_A           = 0;
    ADD_B           = 1;
    ADD_C           = 0;
}



void main() {
        init_serial_port();

        /************************MUX INIT CODES******************************/
        ADD_A_TRIS = 0;
        ADD_B_TRIS = 0;
        ADD_C_TRIS = 0;
        MUX_ENABLE_TRIS = 0;


        ADD_A           = 0;
        ADD_B           = 0;
        ADD_C           = 0;
        MUX_ENABLE      = 0;
        enable_gps_uart();//call this function to communicate with GPS
while(1){

        //YOUR CODE HERE


        }
}